/*
 *      serverdialog.h
 *
 *      Copyright 2008 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef SERVERDIALOG_H
#define SERVERDIALOG_H

#include "defs.h"
#include "fxext.h"

class ServerDialog: public FXDialogBox
{
    FXDECLARE(ServerDialog)
    public:
        ServerDialog(FXMainWindow *owner, dxServerInfoArray servers);
        virtual ~ServerDialog();

        dxServerInfoArray getServers() { return m_serverList; }
        FXint getIndexJoin() { return m_indexJoin; }

        long onJoin(FXObject*,FXSelector,void*);
        long onAdd(FXObject*,FXSelector,void*);
        long onModify(FXObject*,FXSelector,void*);
        long onDelete(FXObject*,FXSelector,void*);
        long onCancel(FXObject*,FXSelector,void*);
        long onSaveClose(FXObject*,FXSelector,void*);
        long onList(FXObject*,FXSelector,void*);
        long onDoubleClick(FXObject*,FXSelector,void*);
        long onKeyPress(FXObject*,FXSelector,void*);

    private:
        ServerDialog():m_indexJoin(0),m_contents(NULL),m_listframe(NULL),m_buttonframe(NULL),m_serverframe(NULL)
        ,m_group(NULL),m_matrix(NULL),m_names(NULL),m_hostname(NULL),m_port(NULL),m_passwd(NULL),m_nick(NULL)
        ,m_realname(NULL),m_autoconnect(NULL),m_usessl(NULL),m_channels(NULL),m_commands(NULL),m_buttonJoin(NULL)
        ,m_buttonAdd(NULL),m_buttonModify(NULL),m_buttonDelete(NULL),m_buttonCancel(NULL),m_buttonSaveClose(NULL)
        {}
        ServerDialog(const ServerDialog&);

        dxServerInfoArray m_serverList;
        FXint m_indexJoin;
        FXVerticalFrame *m_contents, *m_listframe;
        FXHorizontalFrame *m_buttonframe, *m_serverframe;
        FXGroupBox *m_group;
        FXMatrix *m_matrix;
        FXList *m_names;
        FXTextField *m_hostname, *m_port, *m_passwd, *m_nick, *m_realname, *m_autoconnect, *m_usessl;
        FXText *m_channels, *m_commands;
        dxEXButton *m_buttonJoin, *m_buttonAdd, *m_buttonModify, *m_buttonDelete, *m_buttonCancel, *m_buttonSaveClose;

        FXbool hostnameExist(const FXString&, const FXint&, const FXString&);
        void updateList();
        void updateDetails();
};

#endif // SERVERDIALOG_H
