/*
 *      aliasdialog.h
 *
 *      Copyright 2014 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ALIASDIALOG_H
#define ALIASDIALOG_H

#include <QtGui>
#if(QT_VERSION > 0x050000)
#include <QtWidgets>
#endif

class AliasDialog: public QDialog
{
    Q_OBJECT
public:
    explicit AliasDialog(QWidget *parent = 0);
private slots:
    void slotAdd();
    void slotModify();
    void slotDelete();
    void slotSaveClose();
private:
    QTreeWidget *m_table;
    QPushButton *m_buttonAdd, *m_buttonModify, *m_buttonDelete, *m_buttonSaveClose;
    QMap<QString,QString> m_aliases;

    void updateTable();
    bool commandExist(const QString &command);
};

class AliasEditDialog: public QDialog
{
    Q_OBJECT
public:
    explicit AliasEditDialog(const QString &title, QWidget *parent = 0, const QString &alias="", const QString &command="");
    
    QString alias() const { return m_alias->text(); }
    QString command() const { return m_command->text(); }
private:
    QLineEdit *m_alias;
    QLineEdit *m_command;
};

#endif  /* ALIASDIALOG_H */

