/*
 *      fttabitem.h
 *
 *      Copyright 2014 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef FTTABITEM_H
#define FTTABITEM_H

#include <QtGui>
#if(QT_VERSION > 0x050000)
#include <QtWidgets>
#endif
#include "defs.h"

class FtTabItem : public QWidget
{
    Q_OBJECT
public:
    explicit FtTabItem(QWidget *parent = 0);

    DccFile ftForRow(int row);
signals:
    void closeFtTabItem();
    void cancelFt(int);
private slots:
    void slotOk();
    void slotClearCanceled();
    void slotClearFinished();
    void slotItemChanged(QTreeWidgetItem *current);
    void slotItemPopup(const QPoint &pos);
    void slotItemCancel();
    void slotPosition();
private:
    QTreeWidget *m_fileView;
    QPushButton *m_canceled, *m_finished;
    QGroupBox *m_details;
    QLabel *m_path, *m_ip, *m_port, *m_nick;
    QTimer *m_position;

    int rowForFT(DccFile ft) const;
};

#endif // FTTABITEM_H
